/*!
 *@name     jquery.barrager.js
 *@version  1.1
 *@author   yaseng@uauc.net
 *@url      https://github.com/yaseng/jquery.barrager.js
 */


var barragerAnimationRestart = {};

//添加弹幕暂停重启事件
function addAnimationRestart(id,useTime,left,endFunction){
  barragerAnimationRestart[id] = {
    useTime:useTime, //使用时间
    startTime:new Date().getTime(), //开始时间
    surplusTime:0, //剩余时间
    fun:function(surplusTime){
      $(id).animate({left:left},surplusTime,'linear',endFunction);
      addAnimationRestart(id,surplusTime,left,endFunction);
    }
  };
}

// var barragerTimer;
// var barragerTasks = {};
//
// //弹幕滚动定时器
// function startBarragerTimer(){
//   if(barragerTimer != null){
//     return;
//   }
//   barragerTimer = setInterval(function(){
//     var needDeleteId = [];
//     var beforeNumber = 0;
//     for(var id in barragerTasks){
//       beforeNumber++;
//       var speed = barragerTasks[id].speed;
//       var toLeft = barragerTasks[id].toLeft;
//       var currentLeft = barragerTasks[id].currentLeft;
//       currentLeft = currentLeft - speed;
//       if(toLeft < currentLeft){
//         $(id).css("left",currentLeft+"px");
//         barragerTasks[id].currentLeft = currentLeft;
//       }else{
//         barragerTasks[id].endFunction();
//         needDeleteId.push(id);
//       }
//     }
//     for(var i=0;i<needDeleteId.length;i++){
//       var id = needDeleteId[i];
//       delete barragerTasks[id];
//     }
//     if(beforeNumber - needDeleteId.length > 0){
//       startBarragerTimer();
//     }
//   },25);
// }
//
// function stopBarragerTimer(){
//   clearInterval(barragerTimer);
//   barragerTimer = null;
// }

(function($) {

	$.fn.barrager = function(barrage) {
		barrage = $.extend({
			line: -1,
			speed: 8,
			color: '#fff',
			old_ie_color : '#000000',
      class_name : 'barrage'
		}, barrage || {});

    if($(this).length <= 0 ) {
      return;
    }

    var time = new Date().getTime();
		var barrager_id = 'barrage_' + time;
		var id = '#' + barrager_id;
		var div_barrager = $("<div class='"+barrage.class_name+"' id='" + barrager_id + "'>"+barrage.info+"</div>").appendTo($(this));

    var this_width = $(div_barrager).width()+20;
    var this_height = $(div_barrager).height()+8;
    var window_width = $(window).width();

    $(div_barrager).css('width',this_width+"px");
    $(div_barrager).css('height',this_height+"px");

    $(div_barrager).css('left',window_width+"px");

		var top;
		if(barrage.line == -1){
      barrage.line = parseInt(Math.random() * 5);
		}
    top = Math.floor(barrage.line*this_height);

    top += 20;
		div_barrager.css("top", top + "px");
    div_barrager.attr("line",barrage.line);

		if(navigator.userAgent.indexOf("MSIE 6.0")>0  ||  navigator.userAgent.indexOf("MSIE 7.0")>0 ||  navigator.userAgent.indexOf("MSIE 8.0")>0  ){

      div_barrager.css('color', barrage.old_ie_color);

		}else{

      div_barrager.css('color', barrage.color);

		}

		var toLeft = -this_width;
		var useTime = barrage.speed*1000;
    var endFunction = function(){
      $(id).remove();
      //删除恢复滚动效果
      delete barragerAnimationRestart[id];
    };

 		$(id).animate({left:toLeft},useTime,'linear',endFunction);

    // startBarragerTimer();
    //
    // //添加滚动任务
    // barragerTasks[id] = {
    //   speed:2,
    //   toLeft:toLeft,
    //   currentLeft:window_width,
    //   endFunction:endFunction
    // };

    //添加恢复滚动效果
    addAnimationRestart(id,useTime,toLeft,endFunction);

    // var removeTime = 0;
    // if(this_width / window_width > 0 && this_width / window_width <= 0.25){
    //   removeTime = 5;
    //
    // }else if(this_width / window_width > 0.25 && this_width / window_width <= 0.5){
    //   removeTime = 10;
    // }
    // $(id).css("animation","danmuLeft "+removeTime+"s linear");
    //
    // setTimeout(function(){
    //   $(id).remove();
    // },removeTime*1000);
	}

	//暂停字幕滚动
  $.fn.barrager.pauseAll=function(){
    for(var id in barragerAnimationRestart){
      var startTime = barragerAnimationRestart[id].startTime;
      var currentTime = new Date().getTime();

      var useTime = barragerAnimationRestart[id].useTime;
      var pauseUseTime = currentTime - startTime;

      //剩余时长
      var surplusTime = useTime - pauseUseTime;
      barragerAnimationRestart[id].surplusTime = surplusTime;
    }
    $('.barrage').stop(true);
    // stopBarragerTimer();
  }

  //恢复字幕滚动
  $.fn.barrager.restartAll=function(){
    for(var id in barragerAnimationRestart){
      var surplusTime = barragerAnimationRestart[id].surplusTime;

      barragerAnimationRestart[id].startTime = new Date().getTime();
      barragerAnimationRestart[id].useTime = surplusTime;
      barragerAnimationRestart[id].fun(surplusTime);
    }
    // startBarragerTimer();
  }

  //删除所有字幕
	$.fn.barrager.removeAll=function(){
    barragerAnimationRestart = {};
    $('.barrage').stop(true);
		$('.barrage').remove();

    // stopBarragerTimer();
	}

	//删除指定元素下面的字幕
  $.fn.barrager.removeItems=function(parentId){
    var length = $(parentId+' .barrage').length;
    for(var i=0;i<length;i++){
      var id = $(parentId+' .barrage').eq(i).attr('id');
      delete barragerAnimationRestart[id];
    }
    $(parentId+' .barrage').stop(true);
    $(parentId+' .barrage').remove();
  }

})(jQuery);
